# nushell puts prompt at bottom of terminal on resize, so it's preferable to start on the bottom of the terminal

let has_tfetch = not (which tfetch | is-empty)

# tfetch takes 19 lines, 21 with prompt
let height = (stty size | split row " " | get 0 | into int) - (if $has_tfetch { 21 } else { 0 })

# skip lines so that the prompt starts at the bottom of the terminal
for i in 0..<$height {
    print -n "\n"
}

# Start tfetch
if $has_tfetch {
    tfetch
}
